#version 120

uniform sampler2D tex0;
uniform float alphaTest;
uniform vec4 color;

varying float clipPlaneDist; 

void main() {
	if (clipPlaneDist < 0.0)
		discard;
	if (alphaTest < 0)
		gl_FragColor = color;
	else {
		vec4 tex = texture2D(tex0, gl_TexCoord[0].st);
		if (tex.a <= alphaTest)
			discard;
		gl_FragColor = tex*color;	
	}
}