#version 150

layout(triangles) in;
layout(triangle_strip, max_vertices = 18) out;

in vec2 texCoord[];

out FragmentData {
	vec2 texCoord;
} frag;
 
mat3 cubicTransformations[6] = mat3[6] (
	mat3(
		0, 0, -1,
		0, -1, 0,
		-1, 0, 0
	),
	mat3(
		0, 0, 1,
		0, -1, 0,
		1, 0, 0
	),
	mat3(
		1, 0, 0,
		0, 0, -1,
		0, 1, 0
	),
	mat3(
		1, 0, 0,
		0, 0, 1,
		0, -1, 0
	),
	mat3(
		1, 0, 0,
		0, -1, 0,
		0, 0, -1
	),
	mat3(
		-1, 0, 0,
		0, -1, 0,
		0, 0, 1
	)
);
 
void main() {
    for(int j = 0; j < 6; j++) {
        gl_Layer = j;
        for(int i = 0; i < 3; i++) {
            vec3 frag_pos = cubicTransformations[j] * gl_in[i].gl_Position.xyz;
            gl_Position.xy = frag_pos.xy;
            gl_Position.z = -frag_pos.z-2;
            gl_Position.w = -frag_pos.z;
		    frag.texCoord = texCoord[i];
            EmitVertex();
        }
        EndPrimitive();
    }
}