#version 400

#define MAX_LIGHTS 16

uniform mat4 u_modelMatrix;
uniform int u_lightCount;
uniform vec4 u_lightFrustum[MAX_LIGHTS*6];

layout(location = 0) in vec4 attr_Position;
in vec4 attr_TexCoord;

//#define CULL_TRIANGLES_IN 1

out VertexData {
	vec4 position;
	vec2 texCoord;
	float culled[MAX_LIGHTS*6];
} vert;

void main() {
	vert.position = u_modelMatrix * attr_Position;
	//gl_Position = gl_Vertex;
	vert.texCoord = (attr_TexCoord).st;
#ifdef CULL_TRIANGLES_IN
	for (int lightNo = 0; lightNo < u_lightCount; lightNo++) 
	for(int j=lightNo*6; j<lightNo*6+6; j++) {
		float d = dot(vert.position, u_lightFrustum[j]);
		vert.culled[j] = d > 0 ? 1 : 0;
	}
#endif
}